/*
 *  GUI/Widgets/DialogTemplate.cs
 *  Copyright (C) 2007 Marcin Krystian Krzywonos
 *  License: GNU/GPL version 2
 */


using System;
using Gtk;
using Glade;


namespace Incollector.GUI.Widgets {
	
	public class DialogTemplate {
	
		protected Gtk.Dialog dialog;
		protected Gtk.Window ParentWindow;
		protected Glade.XML  GuiXml;
		
		
		public DialogTemplate (string DialogWidgetName, Gtk.Window ParentWindow)
		{
			this.ParentWindow = ParentWindow;
			
			this.GuiXml = Glade.XML.FromAssembly ("gui.glade", DialogWidgetName, null);
			GuiXml.Autoconnect (this);
			
			this.dialog = (Gtk.Dialog) GuiXml.GetWidget (DialogWidgetName);
			this.dialog.TransientFor = ParentWindow;
			this.dialog.VBox.BorderWidth = 0;
			this.dialog.BorderWidth = 0;
			Icons.AssignWindow (this.dialog);
		}
		
		
		public int Run ()
		{
			this.ParentWindow.Sensitive = false;
			
			int res = this.dialog.Run ();
			
			this.ParentWindow.Sensitive = true;
			return res;
		}
		
		
		public void Destroy ()
		{
			this.dialog.Destroy ();
		}
	}
}
